package com.jpattern.orm.generator.javassist;

import com.jpattern.orm.classmapper.IClassMapper;
import com.jpattern.orm.generator.IOrmPersistor;
import com.jpattern.orm.generator.IPersistorGenerator;

/**
 * 
 * @author cinafr
 *
 * @param <T>
 */
public class JavassistPersistorGenerator<T> implements IPersistorGenerator<T> {

	private static String BASE_PACKAGE_NAME = JavassistPersistorGenerator.class.getPackage() + ".generated.";

	private final IClassMapper<T> classMapper;

	private final String classNameSuffix;

	public JavassistPersistorGenerator(IClassMapper<T> classMapper, String classNameSuffix) {
		this.classMapper = classMapper;
		this.classNameSuffix = classNameSuffix;
	}

	@Override
	public IOrmPersistor<T> generate() throws Exception {
		final String className = BASE_PACKAGE_NAME + classMapper.getMappedClass().getCanonicalName() + classNameSuffix;

		final Class<IOrmPersistor<T>> clazz = new JavassistPersistorDump<T>(className, classMapper).createClass();

		return clazz.newInstance();
	}

}