package com.jpattern.orm.generator.reflection;

import com.jpattern.orm.classmapper.IClassMapper;
import com.jpattern.orm.generator.IOrmPersistor;
import com.jpattern.orm.generator.IPersistorGenerator;

/**
 * 
 * @author Francesco Cina'
 *
 * Mar 24, 2012
 */
public class ReflectionPersistorGenerator<T> implements IPersistorGenerator<T> {

	private final IClassMapper<T> classMapper;

	public ReflectionPersistorGenerator(IClassMapper<T> classMapper) {
		this.classMapper = classMapper;
	}

	@Override
	public IOrmPersistor<T> generate() throws Exception {
		return new ReflectionOrmPersistor<T>(classMapper);
	}

}
