package com.jpattern.orm.session;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.transaction.ITransaction;
import com.jpattern.orm.transaction.ITransactionDefinition;
import com.jpattern.orm.transaction.NullTransaction;

/**
 * 
 * @author Francesco Cina'
 *
 * Dec 20, 2011
 */
public class NullSessionStrategy implements ISessionStrategy {

	@Override
	public ITransaction getTransaction(
			ITransactionDefinition transactionDefinition) throws OrmException {
		return new NullTransaction();
	}

	@Override
	public ISqlPerformerStrategy sqlPerformerStrategy() throws OrmException {
		return new NullSqlPerformerStrategy();
	}

}
